<template>
  <div class="lb" v-if="items.length > 0">
    <div
      class="lb-grid"
      :class="items.length > cells ? 'lb-grid-' + cells : 'lb-grid-' + items.length"
    >
      <div
        class="lb-item"
        v-for="(media, i) in items.slice(0, cells)"
        :key="`media-${i}`"
        @click.prevent="open"
        :style="backgroundStyle(media)"
      >
        <div v-if="isVideo(media)" class="play-btn">
          <svg
            xmlns="http://www.w3.org/2000/svg"
            stroke="black"
            stroke-width="1"
            stroke-linecap="butt"
            viewBox="0 0 384 512"
          >
            <path
              d="M73 39c-14.8-9.1-33.4-9.4-48.5-.9S0 62.6 0 80V432c0 17.4 9.4 33.4 24.5 41.9s33.7 8.1 48.5-.9L361 297c14.3-8.7 23-24.2 23-41s-8.7-32.2-23-41L73 39z"
            />
          </svg>
        </div>
        <span class="lb-more" v-if="i == cells - 1 && items.length - cells > 0"
          >+{{ items.length - cells }}</span
        >
      </div>
    </div>

    <Transition name="slide">
      <div v-if="showPost" class="showing-post">
        <div class="sticky-head">
          <button class="btn-back" @click="close">
            <svg xmlns="http://www.w3.org/2000/svg" height="1.5em" viewBox="0 0 320 512">
              <path
                d="M41.4 233.4c-12.5 12.5-12.5 32.8 0 45.3l160 160c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3L109.3 256 246.6 118.6c12.5-12.5 12.5-32.8 0-45.3s-32.8-12.5-45.3 0l-160 160z"
              />
            </svg>
          </button>
          <div class="head-label">
            <span>Post di {{ username }}</span>
          </div>
        </div>

        <div class="scrollable">
          <div
            v-for="(media, i) in items"
            :key="`showing-post-item-${i}`"
            class="showing-post-item"
            @click="openMedia(media)"
          >
            <div v-if="isVideo(media)" class="play-btn">
              <svg xmlns="http://www.w3.org/2000/svg" stroke-linecap="butt" viewBox="0 0 384 512">
                <path
                  d="M73 39c-14.8-9.1-33.4-9.4-48.5-.9S0 62.6 0 80V432c0 17.4 9.4 33.4 24.5 41.9s33.7 8.1 48.5-.9L361 297c14.3-8.7 23-24.2 23-41s-8.7-32.2-23-41L73 39z"
                />
              </svg>
            </div>
            <img :src="media.thumbnail || media.url" />
          </div>
        </div>

        <div class="full-screen-media" :class="{ open: fullScreenMedia }">
          <div v-if="fullScreenMedia">
            <video v-if="isVideo(fullScreenMedia)" controls>
              <source :src="fullScreenMedia.url" />
            </video>
            <img v-else :src="fullScreenMedia.url" alt="" />
          </div>
        </div>
      </div>
    </Transition>
  </div>
</template>

<script>
export default {
  props: {
    items: {
      type: Array,
      default: () => {
        return []
      }
    },
    username: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      showPost: false,
      cells: 5,
      fullScreenMedia: null,
      className: 'no-scroll'
    }
  },
  methods: {
    openMedia(media) {
      if (this.items.length === 1 && !this.isVideo(this.items[0])) {
        return
      }

      this.fullScreenMedia = media
    },
    isVideo(media) {
      return media?.type?.toLowerCase().includes('video')
    },
    open() {
      this.showPost = true

      if (!document.body.classList.contains(this.className)) {
        document.body.classList.add(this.className)
      }
    },
    close() {
      if (this.fullScreenMedia) {
        this.fullScreenMedia = null
        return
      }

      this.showPost = false

      document.body.classList.remove(this.className)

      setTimeout(() => {
        document.querySelectorAll('.showing-post .scrollable').forEach((elem) => {
          elem.scrollTop = 0
        })
      }, 300)
    },
    backgroundStyle(media) {
      if (media?.type?.toLowerCase().startsWith('video/')) {
        return media?.thumbnail ? `background-image: url('${media?.thumbnail}')` : ''
      }
      return media?.url ? `background-image: url('${media?.url}')` : ''
    }
  }
}
</script>

<style lang="less" scoped>
.lb {
  width: 100%;
  height: 450px;
}
.lb-grid {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}

.lb-item {
  position: absolute;
  background-position: center center;
  background-repeat: no-repeat;
  background-size: cover;
  border-top: solid 4px var(--color-background);
  border-right: solid 4px var(--color-background);
  overflow: hidden;
}

.lb-grid-1 .lb-item {
  width: 100%;
  height: 100%;
}

.lb-grid-2 .lb-item,
.lb-grid-3 .lb-item,
.lb-grid-4 .lb-item,
.lb-grid-5 .lb-item {
  width: 50%;
}

.lb-grid-2 .lb-item,
.lb-grid-3 .lb-item:nth-child(1),
.lb-grid-4 .lb-item:nth-child(1) {
  height: 100%;
}

.lb-grid-3 .lb-item:nth-child(2),
.lb-grid-3 .lb-item:nth-child(3),
.lb-grid-5 .lb-item:nth-child(1),
.lb-grid-5 .lb-item:nth-child(2) {
  height: 50%;
}

.lb-item:last-child,
.lb-grid-2 .lb-item:nth-child(2),
.lb-grid-3 .lb-item:nth-child(2),
.lb-grid-3 .lb-item:nth-child(3),
.lb-grid-4 .lb-item:nth-child(2),
.lb-grid-4 .lb-item:nth-child(3),
.lb-grid-4 .lb-item:nth-child(4),
.lb-grid-5 .lb-item:nth-child(3),
.lb-grid-5 .lb-item:nth-child(4),
.lb-grid-5 .lb-item:nth-child(5) {
  left: auto;
  right: 0;
  border-right: 0;
}

.lb-grid-3 .lb-item:nth-child(3),
.lb-grid-4 .lb-item:nth-child(4),
.lb-grid-5 .lb-item:nth-child(2),
.lb-grid-5 .lb-item:nth-child(5) {
  bottom: 0;
  top: auto;
}

.lb-grid-4 .lb-item:nth-child(3),
.lb-grid-5 .lb-item:nth-child(4) {
  top: 33.333333333333336%;
}

.lb-grid-4 .lb-item:nth-child(2),
.lb-grid-4 .lb-item:nth-child(3),
.lb-grid-4 .lb-item:nth-child(4),
.lb-grid-5 .lb-item:nth-child(3),
.lb-grid-5 .lb-item:nth-child(4),
.lb-grid-5 .lb-item:nth-child(5) {
  height: 33.333333333333336%;
}

.lb-more {
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  text-align: center;
  color: #fff;
  font-size: 3rem;
  font-weight: 500;
  background-color: rgba(0, 0, 0, 0.4);
}

.lb-more:before {
  display: inline-block;
  content: '';
  vertical-align: middle;
  height: 100%;
}

.play-btn {
  width: 100%;
  height: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  background: rgba(0, 0, 0, 0.4);

  svg {
    width: 24%;
    opacity: 0.9;

    path {
      fill: #fff;
    }
  }
}

.showing-post {
  position: fixed;
  z-index: 1;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
  padding-top: 65px;
  width: 100%;
  min-height: 100%;
  height: 100vh;
  background: var(--color-background);
  user-select: none;

  .full-screen-media {
    position: absolute;
    top: 65px;
    bottom: 0;
    right: 0;
    left: 0;
    z-index: 1;
    background: var(--color-background);
    transform: translate3d(100%, 0, 0);

    &.open {
      transform: translate3d(0, 0, 0);
    }

    img {
      touch-action: pinch-zoom;
    }

    img,
    video {
      width: 100%;
    }
  }

  &.open {
    transform: translate3d(0, 0, 0);
  }

  .sticky-head {
    height: 65px;
    position: fixed;
    top: 0;
    right: 0;
    left: 0;
    z-index: 999;
    display: flex;
    align-items: center;
    justify-content: space-between;
    background: var(--color-background);

    .btn-back {
      background: none;
      border: 0;
      z-index: 1;

      svg {
        margin-left: 20px;

        path {
          fill: var(--color-text);
        }
      }
    }

    .head-label {
      position: absolute;
      display: flex;
      align-items: center;
      justify-content: center;
      width: 100%;

      span {
        font-weight: 600;
      }
    }
  }

  .showing-post-item {
    width: 100%;
    position: relative;

    img {
      width: 100%;
    }

    .play-btn {
      position: absolute;
      z-index: 1;
    }
  }
}

.slide-leave-active,
.slide-enter-active {
  transition: transform 0.3s cubic-bezier(0.8, 0, 0, 1);
}
.slide-enter {
  transform: translate3d(0, 0, 0);
}
.slide-leave-to {
  transform: translate3d(100%, 0, 0);
}
</style>
